ES6学习笔记(十二)异步解决方案Promise

1.Promise 的含义

Promise 是异步编程的一种解决方案,比传统的解决方案——回调函数和事件——更合理和更强大。它由社区最早提出和实现,ES6 将其写进了语言标准,统一了用法,原生提供了Promise对象

所谓Promise,简单说就是一个容器,里面保存着某个未来才会结束的事件(通常是一个异步操作)的结果

从语法上说,Promise 是一个对象,从它可以获取异步操作的消息。Promise 提供统一的 API,各种异步操作都可以用同样的方法进行处理。

特点:

(1)对象的状态不受外界影响Promise对象代表一个异步操作,有三种状态:pending(进行中)、resolved(已成功)和 rejected(已失败)。Promise的英语意思就是“承诺”,表示其他手段无法改变。

(2)一旦状态改变,就不会再变,任何时候都可以得到这个结果。Promise对象的状态改变,只有两种可能:从pending变为resolved和从pending变为rejected

有了Promise对象,就可以将异步操作以同步操作的流程表达出来避免了层层嵌套的回调函数。此外,Promise对象提供统一的接口,使得控制异步操作更加容易。

Promise也有一些缺点。

  • 首先,无法取消Promise,一旦新建它就会立即执行,无法中途取消。
  • 其次,如果不设置回调函数,Promise内部抛出的错误,不会反应到外部。
  • 第三,当处于pending状态时,无法得知目前进展到哪一个阶段(刚刚开始还是即将完成)。

如果某些事件不断地反复发生,一般来说,使用 Stream 模式是比部署Promise更好的选择。

2. Promise基本用法

const promise = new Promise(function (resolve, reject) { 
    //some code ...
    if (success) {
        resolve(value);
    }else{
        reject(error);
    }
});

ES6 规定,Promise对象是一个构造函数,用来生成Promise实例。

Promise实例接收一个函数作为参数,该函数固定两个参数分别是resolve(通过)和reject (拒绝),分别用来表示异步回调的执行结果,它们是两个函数,由 JavaScript 引擎提供,不用自己部署。

上面这种以函数表达式的方式创建的promise实例的时候,由于调用了构造函数,所以创建实例的同时参数函数function会被执行,而把promise实例作为返回值放在函数里面的时候就不会立即执行。

resolve和reject函数

resolve函数的作用是,将Promise对象的状态从“未完成”变为“成功”(即从 pending 变为 resolved),在异步操作成功时调用,并将异步操作的结果,作为参数传递出去(resolve(success));

reject函数的作用是,将Promise对象的状态从“未完成”变为“失败”(即从 pending 变为 rejected),在异步操作失败时调用,并将异步操作报出的错误,作为参数传递出去(reject(error))。

Promise实例生成以后,可以用then方法分别指定resolved状态和rejected状态的回调函数。

一般的Promise使用方式,包装一个异步操作。

1 function timeout(ms) {
2     return new Promise((resolve, reject) => {
3         setTimeout(resolve, ms, 'done');
4     });
5 }
6 
7 timeout(100).then((value) => {
8     console.log(value);//done
9 })

上面这种以promise作为返回对象的只会在调用的时候执行,然后用函数返回的promise实例再调用then方法拿到异步执行的结果。

下面是异步加载图片的例子。

 1 function loadImageAsync(url) {
 2     return new Promise((resolve, reject) => {
 3         const img = new Image();//图片构造函数
 4     
 5         img.onload = function () { resolve(img) }//加载完成调用resolve函数返回
 6     
 7         img.onerror = function () { reject(new Error('Could not load image at ' + url)) }//加载出错调用reject函数返回
 8     
 9         img.src = url;
10     });
11 }

 上面代码中,使用Promise包装了一个图片加载的异步操作。如果加载成功,就调用resolve方法,否则就调用reject方法。

这个被包装的方法可以当作同步方法一样使用,只需要接收其成功或失败的返回值,而无需使用回调函数获取结果。

如果调用resolve函数和reject函数时带有参数,那么它们的参数会被传递给回调函数。reject函数的参数通常是Error对象的实例,表示抛出的错误;resolve函数的参数除了正常的值以外,还可能是另一个 Promise 实例,比如像下面这样。

const p1 = new Promise(function (resolve, reject) {
    //...
});

const p2 = new Promise(function (resolve, reject) {
    //...
    resolve(p1);
});

上面代码中,p1p2都是 Promise 的实例,但是p2resolve方法将p1作为参数,即一个异步操作的结果是返回另一个异步操作。

注意,这时p1的状态就会传递给p2,也就是说,p1的状态决定了p2的状态。如果p1的状态是pending,那么p2的回调函数就会等待p1的状态改变;如果p1的状态已经是resolved或者rejected,那么p2的回调函数将会立刻执行。

 1 const p1 = new Promise(function (resolve, reject) {
 2     setTimeout(() => reject(new Error('fail')), 3000);
 3 });
 4 
 5 const p2 = new Promise(function (resolve, reject) {
 6     setTimeout(() => resolve(p1), 1000)
 7 });
 8 
 9 p2.then(result => console.log(result)).catch(error => console.log(error));
10 //Error: fail

上面代码中,p1是一个 Promise,3 秒之后变为rejectedp2的状态在 1 秒之后改变,resolve方法返回的是p1由于p2返回的是另一个 Promise,导致p2自己的状态无效了,由p1的状态决定p2的状态。所以,后面的then语句都变成针对后者(p1)。又过了 2 秒,p1变为rejected,导致触发catch方法指定的回调函数。

注意调用resolvereject并不会终结 Promise 的参数函数的执行

1 new Promise(function (resolve, reject) {
2     resolve(1);
3     console.log(2);
4 }).then(function (result) {  
5     console.log(result);
6 });
7 //2
8 //1

上面代码中,调用resolve(1)以后,后面的console.log(2)还是会执行,并且会首先打印出来。这是因为立即 resolved 的 Promise 是在本轮事件循环的末尾执行,总是晚于本轮循环的同步任务

一般来说,调用resolvereject以后,Promise 的使命就完成了,后继操作应该放到then方法里面,而不应该直接写在resolvereject的后面。所以,最好在它们前面加上return语句,这样就不会有意外。

1 new Promise(function (resolve, reject) {
2     return resolve(1);
3     console.log(2);
4 }).then(function (result) {  
5     console.log(result);
6 });
7 //1

3.then函数

Promise 实例具有then方法,也就是说,then方法是定义在原型对象Promise.prototype上的。Promise.prototype.then()。它的作用是为 Promise 实例添加状态改变时的回调函数通俗点来说就是捕获回调函数的返回值

前面说过,then方法的第一个参数是resolved状态的回调函数,第二个参数可选)是rejected状态的回调函数。

then方法返回的是一个新的Promise实例(注意,不是原来那个Promise实例)。因此可以采用链式写法,即then方法后面再调用另一个then方法。

getJSON("/posts.json").then(function(json) {
  return json.post;
}).then(function(post) {
  // ...
});

上面的代码使用then方法,依次指定了两个回调函数。第一个回调函数完成以后,会将返回结果作为参数,传入第二个回调函数

采用链式的then,可以指定一组按照次序调用的回调函数。这时,前一个回调函数,有可能返回的还是一个Promise对象(即有异步操作),这时后一个回调函数,就会等待该Promise对象的状态发生变化,才会被调用。

getJSON("/post/1.json").then(function(post) {
  return getJSON(post.commentURL);
}).then(function funcA(comments) {
  console.log("resolved: ", comments);
}, function funcB(err){
  console.log("rejected: ", err);
});

上面代码中,第一个then方法指定的回调函数,返回的是另一个Promise对象。这时,第二个then方法指定的回调函数,就会等待这个新的Promise对象状态发生变化。如果变为resolved,就调用funcA,如果状态变为rejected,就调用funcB。当然,一般then方法的第二个函数参数省略,而用catch函数统一捕获error。

如果采用箭头函数,上面的代码可以写得更简洁。简洁也就意味着不好理解。。。

getJSON("/post/1.json").then(
  post => getJSON(post.commentURL)
).then(
  comments => console.log("resolved: ", comments),
  err => console.log("rejected: ", err)
);

4.catch函数

Promise.prototype.catch方法是.then(null, rejection).then(undefined, rejection)的别名,用于指定发生错误时的回调函数通俗点来说就是捕获回调函数抛出的异常

 1 // 写法一
 2 const promise = new Promise(function(resolve, reject) {
 3   try {
 4     throw new Error('test');
 5   } catch(e) {
 6     reject(e);
 7   }
 8 });
 9 promise.catch(function(error) {
10   console.log(error);
11 });
12 
13 // 写法二
14 const promise = new Promise(function(resolve, reject) {
15   reject(new Error('test'));
16 });
17 promise.catch(function(error) {
18   console.log(error);
19 });

reject方法抛出回调函数的异常结果,一般由catch函数捕获并处理,否则可能会影响进程执行。

resolve方法抛出回调函数的正常结果,由then函数接收处理。

如果 Promise 状态已经变成resolved,再抛出错误是无效的。

const promise = new Promise(function(resolve, reject) {
  resolve('ok');
  throw new Error('test');
});
promise
  .then(function(value) { console.log(value) })
  .catch(function(error) { console.log(error) });
// ok

上面代码中,Promise 在resolve语句后面,再抛出错误,不会被捕获,等于没有抛出。因为 Promise 的状态一旦改变,就永久保持该状态,不会再变了。

Promise 对象的错误具有“冒泡”性质,会一直向后传递,直到被捕获为止。也就是说,错误总是会被下一个catch语句捕获。所以一连串的then方法连续调用只需要一个catch就可以捕获异常了。

then/catch写法和传统的try/catch写法很是相似,then 约等于 try,跟传统的try/catch代码块不同的是,如果没有使用catch方法指定错误处理的回调函数,Promise 对象抛出的错误不会传递到外层代码,即不会有任何反应。但是会报个unhandledRejection警告。

 1 // bad---不建议这么写
 2 promise
 3   .then(function(data) {
 4     // success
 5   }, function(err) {
 6     // error
 7   });
 8 
 9 // good---应该这么写
10 promise
11   .then(function(data) { //cb
12     // success
13   })
14   .catch(function(err) {
15     // error
16   });
 1 const someAsyncThing = function() {
 2   return new Promise(function(resolve, reject) {
 3     // 下面一行会报错,因为x没有声明
 4     resolve(x + 2);
 5   });
 6 };
 7 
 8 someAsyncThing().then(function() {
 9   console.log('everything is great');
10 });
11 
12 setTimeout(() => { console.log(123) }, 2000);
13 // Uncaught (in promise) ReferenceError: x is not defined
14 // 123

上面代码中,someAsyncThing函数产生的 Promise 对象,内部有语法错误。浏览器运行到这一行,会打印出错误提示ReferenceError: x is not defined,但是不会退出进程、终止脚本执行,2 秒之后还是会输出123。这就是说,Promise 内部的错误不会影响到 Promise 外部的代码,通俗的说法就是“Promise 会吃掉错误”

这个脚本放在服务器执行,退出码就是0(即表示执行成功)。不过,Node 有一个unhandledRejection事件,专门监听未捕获的reject错误,上面的脚本会触发这个事件的监听函数,可以在监听函数里面抛出错误。

注意,Node 有计划在未来废除unhandledRejection事件。如果 Promise 内部有未捕获的错误,会直接终止进程,并且进程的退出码不为 0,所以Promise的调用一定要捕获异常。

一般总是建议,Promise 对象后面要跟catch方法,这样可以处理 Promise 内部发生的错误。catch方法返回的还是一个 Promise 对象,因此后面还可以接着调用then方法

Promise.resolve()
.catch(function(error) {
  console.log('oh no', error);
})
.then(function() {
  console.log('carry on');
});
// carry on

也就是说,当连续调用多个回调函数顺序执行的时候,可以一个回调一个catch,也可以多个回调一个catch,catch和then可以间隔使用,区别在于如果只在最后使用一个catch捕获所有异常,那当中间某个回调抛出异常时,后面的将不会再执行。

 1 new Promise(function (resolve, reject) {
 2     return resolve(111);
 3 }).then(function (result) {  
 4     return new Promise(function (resolve, reject) { resolve(result + 111) });
 5 }).then(function (result) {
 6     return new Promise(function (resolve, reject) { resolve(result + 111) });
 7 }).then(function (result) {
 8     console.log(result);
 9     return new Promise(function (resolve, reject) { reject(new Error('222')) });
10 }).catch(function (error) {
11     console.log(error);
12 });
13 // 333
14 // Error: 222

上面的代码定义了一串顺序执行的回调函数,上一个的返回值作为下一个的参数,每个回调都返回一个Promise实例,然后链式调用,最后使用catch捕获异常。

上面then方法里面执行的是匿名的回调,当然可以调用定义好的函数

p1().then(p2()).then(p3()).then(p4()).catch(error);

p1, p2, p3, p4都是用Promise包裹的回调函数,使用这种方法让其顺序执行,可以用箭头函数来简化具体的过程。

 1 function p1(result) {
 2     return new Promise((resolve, reject) => {
 3         resolve(result + 111);
 4     });
 5 }
 6 function p2(result) {
 7     return new Promise((resolve, reject) => {
 8         resolve(result + 111);
 9     });
10 }
11 function p3(result) {
12     return new Promise((resolve, reject) => {
13         resolve(result + 111);
14     });
15 }
16 function p4(result) {
17     return new Promise((resolve, reject) => {
18         reject(new Error(result + 111));
19     });
20 }
21 
22 p1(111).then(result => p2(result)).then(result => p3(result)).then(result => p4(result)).catch(error => {console.log(error)});
23 // Error: 555

上面是简化后的顺序执行例子,p1传入111,最后p4异常结果输出555,这便是then和catch函数的用法。

 5.finally函数

就像try-catch-finally一样,也有then-catch-finally结构,finally同样用来指定那些必须一定会执行大的操作,比如关闭流。该方法是 ES2018 引入标准的。

promise
.then(result => {···})
.catch(error => {···})
.finally(() => {···});

finally方法的回调函数不接受任何参数,这意味着没有办法知道,前面的 Promise 状态到底是fulfilled还是rejected

这表明,finally方法里面的操作,应该是与状态无关的,不依赖于 Promise 的执行结果

finally本质上是then方法的特例

 1 promise
 2 .finally(() => {
 3   // 语句
 4 });
 5 
 6 // 等同于
 7 promise
 8 .then(
 9   result => {
10     // 语句
11     return result;
12   },
13   error => {
14     // 语句
15     throw error;
16   }
17 );

上面代码中,如果不使用finally方法,同样的语句需要为成功和失败两种情况各写一次。有了finally方法,则只需要写一次。

6.Promise.all()

上面使用链式调用then方法可以将多个promise实例顺序执行,但Promise的功能当然不仅仅于此,对于需要并行的多个异步操作,就需要使用all()方法了。

Promise.all方法用于将多个 Promise 实例,包装成一个新的 Promise 实例。

const p = Promise.all([p1, p2, p3]);

Promise.all方法接受一个数组作为参数p1p2p3都是 Promise 实例,如果不是,就会先调用下面讲到的Promise.resolve方法,将参数转为 Promise 实例,再进一步处理。然后数组中的promise实例就会并行执行,这是一个公平的并行。(Promise.all方法的参数可以不是数组,但必须具有 Iterator 接口,且返回的每个成员都是 Promise 实例。也就是说可以是set等类数组)。

然后这个新的Promise 实例p的状态由其子实例 p1, p2, p3的状态决定,分两种情况:

1、成功:子实例全部成功才算成功(resolve);

2、失败:子实例只要有一个失败就算失败(reject);

有点像逻辑运算符的 &&,全真为真,一假则假。

注意,如果作为参数的 Promise 实例,自己定义了catch方法,那么它一旦被rejected,并不会触发Promise.all()catch方法。

 1 const p1 = new Promise((resolve, reject) => {
 2   resolve('hello');
 3 })
 4 .then(result => result)
 5 .catch(e => e);
 6 
 7 const p2 = new Promise((resolve, reject) => {
 8   throw new Error('报错了');
 9 })
10 .then(result => result)
11 .catch(e => e);
12 
13 Promise.all([p1, p2])
14 .then(result => console.log(result))
15 .catch(e => console.log(e));
16 // ["hello", Error: 报错了]

上面代码中,p1resolvedp2首先会rejected,但是p2有自己的catch方法,该方法返回的是一个新的 Promise 实例,p2指向的实际上是这个实例。该实例执行完catch方法后,也会变成resolved,导致Promise.all()方法参数里面的两个实例都会resolved,因此会调用then方法指定的回调函数,而不会调用catch方法指定的回调函数。

如果p2没有自己的catch方法,就会调用Promise.all()catch方法

7.Promise.race()

然而物竞天择,适者生存,共同富裕只是少数,更多的是你死我活的竞争,race()方法便是用来做这种事。

const p = Promise.race([p1, p2, p3]);

上面代码中,只要p1p2p3之中有一个实例率先改变状态,p的状态就跟着改变。那个率先改变的 Promise 实例的返回值,就传递给p的回调函数。

即一组子实例中只要有一个成功,就返回成功结果,其他的被淘汰,全部失败,就返回失败。

就像逻辑运算符的 || : 一真为真,全假则假。

这种机制可以定义一个固定时间的回调,用来限制回调的返回时间,而不必一直等待结果。

8.Promise.resolve() 

有时需要将现有对象转为 Promise 对象Promise.resolve方法就起到这个作用。

Promise.resolve('foo')
// 等价于
new Promise(resolve => resolve('foo'))

Promise.resolve方法的参数分成四种情况。

(1)参数是一个 Promise 实例

如果参数是 Promise 实例,那么Promise.resolve将不做任何修改、原封不动地返回这个实例。

(2)参数是一个thenable对象

 

thenable对象指的是具有then方法的对象,比如下面这个对象。

let thenable = {
  then: function(resolve, reject) {
    resolve(42);
  }
};

Promise.resolve方法会将这个对象转为 Promise 对象,然后就立即执行thenable对象的then方法

 1 let thenable = {
 2   then: function(resolve, reject) {
 3     resolve(42);
 4   }
 5 };
 6 
 7 let p1 = Promise.resolve(thenable);
 8 p1.then(function(value) {
 9   console.log(value);  // 42
10 });

上面代码中,thenable对象的then方法执行后,对象p1的状态就变为resolved,从而立即执行最后那个then方法指定的回调函数,输出 42。

(3)参数不是具有then方法的对象,或根本就不是对象

如果参数是一个原始值,或者是一个不具有then方法的对象,则Promise.resolve方法返回一个新的 Promise 对象,状态为resolved

const p = Promise.resolve('Hello');

p.then(function (s){
  console.log(s)
});
// Hello

(4)不带有任何参数

Promise.resolve方法允许调用时不带参数,直接返回一个resolved状态的 Promise 对象。

所以,如果希望得到一个 Promise 对象,比较方便的方法就是直接调用Promise.resolve方法。

const p = Promise.resolve();

p.then(function () {
  // ...
});

需要注意的是,立即resolve的 Promise 对象,是在本轮“事件循环”(event loop)的结束时,而不是在下一轮“事件循环”的开始时,所以打算直接用这种方法定义某个开头的打算落空了,只能做收尾。

 1 setTimeout(function () {
 2   console.log('three');
 3 }, 0);
 4 
 5 Promise.resolve().then(function () {
 6   console.log('two');
 7 });
 8 
 9 console.log('one');
10 
11 // one
12 // two
13 // three

上面代码中,setTimeout(fn, 0)在下一轮“事件循环”开始时执行,Promise.resolve()在本轮“事件循环”结束时执行,console.log('one')则是立即执行,因此最先输出。

9.Promise.reject()

与resolve()方法相反,Promise.reject(reason)方法也会返回一个新的 Promise 实例,该实例的状态为rejected

1 const p = Promise.reject('出错了');
2 // 等同于
3 const p = new Promise((resolve, reject) => reject('出错了'))
4 
5 p.then(null, function (s) {
6   console.log(s)
7 });
8 // 出错了

注意Promise.reject()方法的参数,会原封不动地作为reject的理由,变成后续方法的参数。这一点与Promise.resolve方法不一致。

 1 const thenable = {
 2   then(resolve, reject) {
 3     reject('出错了');
 4   }
 5 };
 6 
 7 Promise.reject(thenable)
 8 .catch(e => {
 9   console.log(e === thenable)
10 })
11 // true

上面代码中,Promise.reject方法的参数是一个thenable对象,执行以后,后面catch方法的参数不是reject抛出的“出错了”这个字符串,而是thenable对象。

10.Promise.try()

实际开发中,经常遇到一种情况:不知道或者不想区分,函数f是同步函数还是异步操作,但是想用 Promise 来处理它。因为这样就可以不管f是否包含异步操作,都用then方法指定下一步流程,用catch方法处理f抛出的错误。一般就会采用下面的写法。

Promise.resolve().then(f)

上面的写法有一个缺点,就是如果f是同步函数,那么它会在本轮事件循环的末尾执行。因为promise串行总是按then的顺序的。

const f = () => console.log('now');
Promise.resolve().then(f);
console.log('next');
// next
// now

上面代码中,函数f是同步的,但是用 Promise 包装了以后,就变成异步执行了。

结尾:Promise是优秀的异步解决方案,也是后面async/await方案的本质基础,化异步为同步的方式还是很舒服的。

posted @ 2019-03-21 08:10  姬无华  阅读(631)  评论(4编辑  收藏  举报